# Time-stamp: <2019-08-30 11:05:13 phm>

package A2E::Hanzi::KonvTest;

=head1 NAME

A2E::Hanzi::KonvTest

=head1 TODO

=head1 PREREQUISITES

=cut

use base 'Test::Unit::TestCase';
use A2E::Hanzi::Konv;

=head1 IMPLEMENTATION

=cut

binmode STDIN, ':utf8';
binmode STDOUT, ':utf8';
binmode STDERR, ':utf8';
use strict;
use utf8;
use Encode qw(_utf8_on);
use warnings;
use diagnostics;
use Scalar::Util qw(blessed);
use Data::Dumper;
use File::Spec::Functions qw(catfile catdir);
use Cwd;
use Encode qw(_utf8_on);
# sub new { my $self = shift()->SUPER::new(@_) };

our ($p);

sub set_up {
    my $m = shift;
    $p = new_ready A2E::Hanzi::Konv konv => 'x2tw';
};

sub test_konfig {
    my $m = shift;
    $m->assert_equals('A2E::Hanzi::Konv', blessed $p);
}

sub test_konv {
    my $m = shift;
    my $fi = 'jianti.txt';
    my $fo = 'fanti.txt';
    $p->open_fayl($fi, 'i', 'w');
    my $s0 = '要进行简体对繁体的转换';
    $p->print_tu_fayl('i', $s0."\n");
    my $s1 = '要進行簡體對繁體的轉換';
    my $sf = $s1;
    my $s2 = $p->konv($s0);
    $m->assert_equals($s1, $s2);
    $s0 = '对软件中的数据与程序进行打印';
    $p->print_tu_fayl('i', $s0."\n");
    $s1 = '對軟體中的資料與程式進行列印';
    $sf = join "\n", $sf, $s1;
    $s2 = $p->konv($s0);
    $m->assert_equals($s1, $s2);
    $p->kloz_fayl('i');
    $p->out2sav($fo);
    $p->konv_faylz($fi);
    my $sf1 = $p->fayl_get_str($fo);
    $m->assert_equals($sf, $sf1);
    unlink $fi, $fo;
}
sub test_none {
    my $m = shift;
    return 1;
}
sub tear_down {
    # print STDERR "取り下げ\n";
};

# our @TESTS = qw(test_konfig test_none);

=head1 The END

=cut

return 1;

# Local Variables:
# coding: utf-8
# srcfile:/adv/perl/A2E/Hanzi/KonvTest.pm
# mode: perl
# End:

