#!/usr/bin/perl
# Time-stamp: <2019-09-07 10:50:19 phm>
BEGIN { $ENV{'PATH'} = '/opt/a2e/bin:/bin:/usr/bin' };
use strict;

=head1 NAME

    A2E::LngFaylz

=head1 VERSION

    This describes version B<0.0.1>

=cut

    our $VERSION = '0.0.1';

=head1 SYNOPSIS

    use A2E::LngFaylz 
    my $p = new_ready A2E::LngFaylz;
    my ($lang, $dok) = @ARGV;
    $p->print_lng_faylz($lang, $dok);

=head1 DESCRIPTION

print out the list of lexical definition files for a (given or found) language and document.

=cut

package A2E::LngFaylz;
use strict;
use base 'A2E::Dokfs';

=head1 OPTIONS

=cut

sub defvars {
    my ($m,$prog,$lihs) = shift->qlpuc('A2E::LngFaylz::defvars', @_) or return;

=over

=item Inherited Options

from A2E::LngFaylz and ancestors

=cut

    $m->SUPER::defvars($lihs);

=item --readable

list only those vocabulary files that really exist

=cut

    $m->{konfig}->define('readable|r!');

=item --pairs

list not only the file of the given language but also language-neutral files and, where appropriate, the source language file

=cut

    $m->{konfig}->define('pairs|par!');

=back

=head1 FILES

	/lng_faylz.konf
	~/.lng_faylz_konf
	./@lng_faylz

=cut

    $m->konfayl('lng_faylz.konf');
    $m->qpop1($prog,1);
};

sub print_lng_faylz {
    my ($m,$prog,$lihs,$lang,$dok) = shift->lpuc('print_lng_faylz',@_);
    $dok ||= $m->get_dok;
    my @langs = $m->get_langs($lihs);
    $lang ||= $langs[0];
    $m->set_alidoks;
    $m->set_dok($dok);
    my ($pre,$lng)= $m->lng_faylz($lang, $dok, par => $m->konfget('pairs'), readable => $m->konfget('readable'), tmpl => $m->{konfig}->tmpl);
    for ($pre,$lng) {
	next unless $_;
	my $s = join ' ', @_;
	print $s . "\n";
    };
    $m->dpop($prog, @faylz);
};

=head1 THE END

=cut 

return 1;

# Local Variables:
# coding: utf-8
# srcfile: /adv/perl/A2E/LngFaylz.pm.tmpl
# mode: perl
# End:
