# Time-stamp: <2019-08-29 07:57:55 phm>

package A2E::MLHTTest;

=head1 NAME

A2E::SarbTest

=head1 PREREQUISITES

=cut

use base 'Test::Unit::TestCase';
use A2E::MLHT;

=head1 IMPLEMENTATION

=cut

binmode STDIN, ':utf8';
binmode STDOUT, ':utf8';
binmode STDERR, ':utf8';
use strict;
use utf8;
use Encode qw(_utf8_on);
use warnings;
use diagnostics;
use Scalar::Util qw(blessed);
use Data::Dumper;

# sub new { my $self = shift()->SUPER::new(@_) };

our ($p, $lihs, $optsr, $str, $arb);

sub set_up {
    my $m = shift;
    $p = new_ready A2E::MLHT;
    $lihs = $p->get_lihs;
    $optsr = { msglini => 1, insistp => 1, lihs => $lihs };
};

sub test_konfig {
    my $m = shift;
    $m->assert_equals(blessed $p, 'A2E::MLHT');
    $m->assert_not_null($p->{sarb});
    $m->assert_equals(blessed $p->{sarb}, 'A2E::SArb::Make');
    my $tmplopts = $p->pvar('tmplopts');
    $m->assert_not_null($tmplopts->{INCLUDE_PATH});
    $m->assert_equals('.', $tmplopts->{INCLUDE_PATH}->[0]);
    $m->assert_not_null($p->pvar('tmpl'));
    $m->assert(@{$tmplopts->{INCLUDE_PATH}} > 3);
    $m->assert_not_null($p->{template});
    $m->assert_equals(blessed $p->{template}, 'Template');
};

sub test_pars {
    my $m = shift;
    my $key = 'ffii';
    my $val = 'Förderverein für eine Freie Informationelle Infrastruktur e.V.';
    my $lini = "$key := $val";
    $p->tmplini($optsr,$lini);
    $m->assert_equals($val,$lihs->getstr($key));
    $key = 'ffiimuc';
    my $val0 = '${ffii}' . ' in München';
    my $val1 = $val . ' in München';
    $lini = "$key := $val0";
    $p->tmplini($optsr,$lini); 
    $m->assert_equals($val1,$lihs->getstr($key));
};

sub tear_down {
    print STDERR "取り下げろ\n";
    print STDERR Dumper $p->{tmplvars};
};

# our @TESTS = qw(test_konfig test_pars);

=head1 The END

=cut

return 1;

# Local Variables:
# coding: utf-8
# srcfile:/adv/perl/A2E/MLHTTest.pm
# mode: perl
# End:

