# -*- Coding: utf-8; srcfile:/adv/perl/A2E/Daba.pm; mode: perl -*-
# Time-stamp: <2008-07-07 23:56:22 phm>

=head1 NAME

A2E::Mason

=cut

package A2E::Mason;
use strict;
use utf8;

=head1 DESCRIPTION

Wrapper for Mason, to be used in httpd.conf instead of HTML::Mason::ApacheHandler

=head1 SYNOPSIS

=head1 BUGS, LIMITATIONS

Not there yet.

=head1 Related Systems

=head2 PREREQUISITES

    HTML::Mason(3)

=cut

use base 'HTML::Mason::ApacheHandler';

my %ah;
my @sites = qw(a2e eupat ffiinnc);
foreach my $site (@sites) {
    $ah{$site} = new HTML::Mason::ApacheHandler comp_root => "/foldi/svn/$site", data_dir => "/var/opt/a2e/mason/$site" ;
};

sub handler {
    my $r = shift;
    my $site = $r->dir_config('SiteName'); 
    return $r->DECLINED unless exists $ah{$site};
    return $ah{$site}->handle_request($r);
}

return 1;

# Local Variables:
# coding: utf-8
# srcfile:/adv/perl/A2E/Mason.pm
# mode: perl
# End:
