# -*- coding: utf-8; mode: perl; srcfile: /adv/perl/A2E/Template/Directive.pm -*-
# Time-stamp: <2009-04-27 11:57:58 phm>

=head1 NAME

A2E::Template::Directive

=cut

package A2E::Template::Directive;

=head1 DESCRIPTION

Subclass Template::Directives to add more directives, so as to better support the A2E text building (Textbau) language.

Currently this is an empty subclass.

To really add directives, it would be necessary to register them in 

    /ul/src/svn/Template2/parser/Parser.yp

and compile the new syntax through YACC-based tools so as to generate a new Template::Grammar module.

=cut

use base 'Template::Directive';
use A2E::SArb::Make;

=head1 TODO

 - get exercise with YACC, add some simple stupid directives
 - add directives that help make even non-mlht source texts completely independet of output converters, e.g. the directive LISTWRAPPER with its subelement ITEM used in the following example.

    [% LISTWRAPPER enumlist -%]
    [% ITEM %]{ah url=munnL2_pass.asc:Kennsatz}[% END %]
    [% ITEM %]{ah dok=a2e_cryptfs:Erfahrungen und Konventionen im Bereich der Datenträgerverschlüssselung bei A2E}[% END -%]
    [% ITEM %]{ah url=munnL2_cdrom.tar.bz2:Dokumentation auf der mitgelieferten CDROM}
    [% LISTWRAPPER tititemlist %] 
    [% ITEM %]Roter Teil[% END -%]
    [% ITEM %]Blauer Teil[% END -%]
    [% ITEM %]Gruener Teil[% END -%]
    [% END %][%# enumlist.item.tititemlist -%]
    [% END %][%# enumlist.item -%] 
    [% END %][%# enumlist -%]

   This listwrapper directive should have an internal listlevel variable which can be used by the formatting directive that is handed to it as its first argument.  The listlevel is incremented at every nesting level.
   Without this directive, it is not possible to write formatter-independent document with TT2.  With this directive, all kinds of menus, lists and tables can be written cleanly.  Once we are free to open one dimension, we have all dimensions.  The current wrapper directive is zero-dimensional.

=cut

return 1;
