# -*- coding: utf-8; mode: perl; srcfile: /adv/perl/A2E/Template/Plugin/TextbauCall.pm -*-
# Time-stamp: <2009-02-24 14:13:21 phm>

=head1 NAME

    A2E::Template::Plugin::TextbauCall;    

=cut

package A2E::Template::Plugin::TextbauCall;

=head1 SYNOPSIS

In Document:

    [% USE TextbauCall %]
    [% 'pi is ${1}' | call '3.14' %]
    [% 'pi is ${pi}' | call %]

=head1 DESCRIPTION

Simpler version of A2E::Template::Plugin::Textbau, provides only the 'call' function.
Now obsolete, say

    [% USE Textbau %]
    [% 'pi is ${1}' | tb 'call' '3.14' %]
    [% 'pi is ${pi}' | tb %]

instead.

=cut

use Template::Plugin::Filter;
# use Template::Parser;
# use Template::Directive;
# $Template::Parser::DEBUG = 1;
# $Template::Directive::PRETTY = 1;
use base qw(Template::Plugin::Filter);
use A2E::SArb::Make;
use Data::Dumper;

sub init {
    my $m = shift;
    $m->{ _DYNAMIC } = 1;
    $m->install_filter($m->{ _ARGS }->[0] || 'call');
    $m->{SArb} = new_ready A2E::SArb::Make debug => $ENV{DEBUG}, verbose => $ENV{VERBOSE};
    return $m;
}

sub filter {
    my $m = shift;
    $m->{SArb}->dpuc('filter', @_);
    my ($text, $args, $config) = @_;
    my $context = $m->{_CONTEXT};
    $config = $m->merge_config($config);
    # $m->{SArb}->{debug} = 0;
    $m->{SArb}->{vars} = $context->{STASH};
    $m->{SArb}->{arbs} = $context->{STASH}->{__ARBS__};
    $m->{SArb}->dgot(vars => [ keys %{$m->{SArb}->{vars}} ], arbs => [ keys %{$m->{SArb}->{arbs}} ], funs => [ keys %{$m->{SArb}->{funs}} ]);
    my $arb = $m->{SArb}->parse($text);
    $m->{SArb}->dgot(arb => $arb, text => $text, args => $args);
    my @arglist = @$args;
    my $n = 0;
    my $vars = {};
    while (my $arg = shift @arglist) { $vars->{++$n} = $arg };
    $text = $m->{SArb}->render($vars, $arb);
    $m->{SArb}->dpop('filter', $text);
    # $m->{SArb}->{debug} = 0;
    return $text;
}

1;


